# Running the Project with Docker

This section provides instructions to build and run the project using Docker.

## Requirements

- Docker version 20.10 or later
- Docker Compose version 1.29 or later

## Environment Variables

- `POSTGRES_USER`: Database username (default: `user`)
- `POSTGRES_PASSWORD`: Database password (default: `password`)
- `POSTGRES_DB`: Database name (default: `appdb`)

## Build and Run Instructions

1. Clone the repository and navigate to the project root directory.
2. Build and start the services using Docker Compose:
   ```bash
   docker-compose up --build
   ```
3. Access the application at `http://localhost:8080`.

## Configuration

- The application binary is built using Go version 1.24.
- The database service uses the `postgres:latest` image.

## Exposed Ports

- Application: `8080` (mapped to `8080` on the host)
- Database: Not exposed to the host

For further details, refer to the project documentation or contact the maintainers.